// ======================================================
// Abstracts :: Mixins
// ======================================================

// Responsive
$screen-xs: 576px;
$screen-sm: 768px;
$screen-md: 992px;
$screen-lg: 1200px;
$screen-xlg: 1440px;
$screen-xxlg: 1600px;

@mixin breakpoints($media) {
    @if $media==xs {
      @media only screen and (min-width: $screen-xs) {
        @content;
      }
    }

    @else if $media==sm {
        @media only screen and (min-width: $screen-sm) {
            @content;
        }
    }

    @else if $media==md {
        @media only screen and (min-width: $screen-md) {
            @content;
        }
    }

    @else if $media==lg {
        @media only screen and (min-width: $screen-lg) {
            @content;
        }
    }

    @else if $media==xlg {
        @media only screen and (min-width: $screen-xlg) {
            @content;
        }
    }

    @else if $media==xxlg {
        @media only screen and (min-width: $screen-xxlg) {
            @content;
        }
    }

    @else if $media==max-xxlg {
      @media only screen and (max-width: $screen-xxlg - 1) {
          @content;
      }
    }

    @else if $media==max-xlg {
        @media only screen and (max-width: $screen-xlg - 1) {
            @content;
        }
    }

    @else if $media==max-lg {
        @media only screen and (max-width: $screen-lg - 1) {
            @content;
        }
    }

    @else if $media==max-md {
        @media only screen and (max-width: $screen-md - 1) {
            @content;
        }
    }

    @else if $media==max-sm {
        @media only screen and (max-width: $screen-sm - 1) {
            @content;
        }
    }

    @else if $media==max-xs {
        @media only screen and (max-width: $screen-xs - 1) {
            @content;
        }
    }

    @else if $media==xs-sm {
        @media only screen and (min-width: $screen-xs) and (max-width: $screen-sm - 1) {
            @content;
        }
    }

    @else if $media==xs-md {
        @media only screen and (min-width: $screen-xs) and (max-width: $screen-md - 1) {
            @content;
        }
    }

    @else if $media==sm-md {
        @media only screen and (min-width: $screen-sm) and (max-width: $screen-md - 1) {
            @content;
        }
    }

    @else if $media==md-lg {
        @media only screen and (min-width: $screen-md) and (max-width: $screen-lg - 1) {
            @content;
        }
    }

    @else if $media==sm-lg {
        @media only screen and (min-width: $screen-sm) and (max-width: $screen-lg - 1) {
            @content;
        }
    }

    @else if $media==xs-lg {
        @media only screen and (min-width: $screen-xs) and (max-width: $screen-lg - 1) {
            @content;
        }
    }
}

// position Mixin
@mixin position($position, $top: null, $right: null, $bottom: null, $left: null) {
    position: $position;
    top: $top;
    right: $right;
    bottom: $bottom;
    left: $left;
}

@mixin position-top-left($top: null,$left: null) {
  position: absolute;
  top: $top;
  left: $left;
}

@mixin position-top-right($top: null, $right: null, ) {
  position: absolute;
  top: $top;
  right: $right;
}

@mixin position-bottom-left($bottom: null, $left: null) {
  position: absolute;
  bottom: $bottom;
  left: $left;
}

@mixin position-bottom-right($bottom: null, $right: null) {
  position: absolute;
  bottom: $bottom;
  right: $right;
}

//Center Block
@mixin center-block ($width) {
  width: $width;
  display: block;
  margin: 0 auto;
}

//Border Radius
@mixin border-radius($radius) {
    -webkit-border-radius: $radius;
    border-radius: $radius;
    background-clip: padding-box;  /* stops bg color from leaking outside the border: */
}

// Single side border-radius
@mixin border-top-radius($radius) {
    -webkit-border-top-right-radius: $radius;
    border-top-right-radius: $radius;
    -webkit-border-top-left-radius: $radius;
    border-top-left-radius: $radius;
    background-clip: padding-box;
}
@mixin border-right-radius($radius) {
    -webkit-border-bottom-right-radius: $radius;
    border-bottom-right-radius: $radius;
    -webkit-border-top-right-radius: $radius;
    border-top-right-radius: $radius;
    background-clip: padding-box;
}
@mixin border-bottom-radius($radius) {
    -webkit-border-bottom-right-radius: $radius;
    border-bottom-right-radius: $radius;
    -webkit-border-bottom-left-radius: $radius;
    border-bottom-left-radius: $radius;
    background-clip: padding-box;
}
@mixin border-left-radius($radius) {
    -webkit-border-bottom-left-radius: $radius;
    border-bottom-left-radius: $radius;
    -webkit-border-top-left-radius: $radius;
    border-top-left-radius: $radius;
    background-clip: padding-box;
}

// CSS Triangles Mixin
@mixin css-triangle($direction, $color, $height, $width) {
    // Base styles for all triangles
    border-style: solid;
    height: 0;
    width: 0;
    // Cardinal Directions - can't be scalene this way
    @if($direction == 'top') {
        border-color: transparent transparent $color transparent;
        border-width: 0 ($width/2) $height ($width/2);
    }
    @if ($direction == 'bottom') {
        border-color: $color transparent transparent transparent;
        border-width: $height ($width/2) 0 ($width/2);
    }
    @if ($direction == 'right') {
        border-color: transparent transparent transparent $color;
        border-width: ($height/2) 0 ($height/2) $width;
    }
    @if ($direction == 'left') {
        border-color: transparent $color transparent transparent;
        border-width: ($height/2) $width ($height/2) 0;
    }
    // Ordinal Directions - can be scalene this way!
    @if ($direction == 'top-left') {
        border-color: $color transparent transparent transparent;
        border-width: $height $width 0 0;
    }
    @if ($direction == 'top-right') {
        border-color: transparent $color transparent transparent;
        border-width: 0 $width $height 0;
    }
    @if ($direction == 'bottom-left') {
        border-color: transparent transparent transparent $color;
        border-width: $height 0 0 $width;
    }
    @if ($direction == 'bottom-right') {
        border-color: transparent transparent $color transparent;
        border-width: 0 0 $height $width;
    }
}



//Box shadow
@mixin box-shadow($top, $left, $blur, $color, $inset: false) {
    @if $inset {
        -webkit-box-shadow:inset $top $left $blur $color;
        -moz-box-shadow:inset $top $left $blur $color;
        box-shadow:inset $top $left $blur $color;
    } @else {
        -webkit-box-shadow: $top $left $blur $color;
        -moz-box-shadow: $top $left $blur $color;
        box-shadow: $top $left $blur $color;
    }
}
//Text Shadow
@mixin text-shadow($top, $left, $blur, $color) {
    -webkit-text-shadow: $top $left $blur $color;
    -moz-text-shadow: $top $left $blur $color;
    text-shadow: $top $left $blur $color;
}

/*Placeholders*/
//@mixin placeholder-color($color) {
//    &.placeholder {
//        color: $color
//    }
//
//    &:-moz-placeholder {
//        color: $color
//    }
//
//    &::-webkit-input-placeholder {
//        color: $color
//    }
//
//    &:-ms-input-placeholder {
//        color: $color
//    }
//}

/*--------------------------------
	Responsive ratio
	Used for creating scalable elements that maintain the same ratio
	example: .element { @include responsive-ratio(400, 300); }
*/
@mixin responsive-ratio($x,$y, $pseudo: false) {
  $padding: unquote( ( $y / $x ) * 100 + '%' );

  @if $pseudo {
    &::before {
      @include pseudo($pos: relative);
      width: 100%;
      padding-top: $padding;
    }
  } @else {
    padding-top: $padding;
  }
}

@mixin responsive-ratio-img($option: cover){
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  object-fit: $option;
}


//Transition
@mixin transition($args...) {
    -webkit-transition: $args;
    -moz-transition: $args;
    transition: $args;
}

// Browser Prefixes
@mixin transform($transforms) {
    -webkit-transform: $transforms;
    -moz-transform: $transforms;
    transform: $transforms;
}

// Rotate
@mixin rotate ($deg) {
    @include transform(rotate(#{$deg}deg));
}

// Scale
@mixin scale($scale) {
    @include transform(scale($scale));
}

// Translate
@mixin translate ($x, $y) {
    @include transform(translate($x, $y));
}

// Skew
@mixin skew ($x, $y) {
    @include transform(skew(#{$x}deg, #{$y}deg));
}

// Transform Origin
@mixin transform-origin ($origin) {
    -webkit-transform-origin: $origin;
    -moz-transform-origin: $origin;
    transform-origin: $origin;
}

//Backgroud Gradien Vertical Y
@mixin linear-gradient-v ($from, $to) {
    background-color: $from;
    background-image: -webkit-linear-gradient(top, $from, $to); /* Chrome 10-25, iOS 5+, Safari 5.1+ */
    background-image:         linear-gradient(to bottom, $from, $to); /* Chrome 26, Firefox 16+, IE 10+, Opera 12.10+ */
}

//Backgroud Gradien Horizontal X
@mixin linear-gradient-h ($from, $to) {
    background-color: $from;
    background-image: -webkit-linear-gradient(left, $from, $to); /* Chrome 10-25, iOS 5+, Safari 5.1+ */
    background-image:         linear-gradient(to right, $from, $to); /* Chrome 26, Firefox 16+, IE 10+, Opera 12.10+ */
}


//Color RGBA
@mixin transparent-backgound($color: #000, $value:0.5){
    $start: "rgb(";
    $end: ")";
    background: #{$start}red($color), green($color), blue($color)#{$end};
    background: rgba($color, $value);
}

/*Truncate*/
%line-text {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

%truncate{
  max-width: 100%;
  @extend %line-text;
}

//Line number
@mixin line-number ($number) {
    overflow: hidden;
    text-overflow: ellipsis;
    display: -webkit-box;
    -webkit-line-clamp: $number;
    -webkit-box-orient: vertical;
}

%scroll-bar {
  overflow-x: hidden;
  overflow-y: auto;
  &::-webkit-scrollbar {
    width: 4px;
    height: 4px;
    border-radius: 999px;
  }

  &::-webkit-scrollbar-track {
    background: #F1F1F1;
    border-radius: 999px;
  }

  &::-webkit-scrollbar-thumb {
    background: $primary;
    border-radius: 999px;
  }

  &::-webkit-scrollbar-thumb:hover {
    background: #F1F1F1;
    border-radius: 999px;
  }
}

@mixin row-padding($index:5px){
  margin-left:-$index;
  margin-right: -$index;
  >.custom-width-header,
  > .col,
  >[class*="col-"]{
    padding-left: $index;
    padding-right: $index;
  }
}

// mixin flex
%flexbox {
  display: -webkit-box;
  display: -moz-box;
  display: -ms-flexbox;
  display: -webkit-flex;
  display: flex;
}

@mixin flexbox() {
  display: -webkit-box;
  display: -moz-box;
  display: -ms-flexbox;
  display: -webkit-flex;
  display: flex;
}

%item-center {
  @extend %flexbox;
  align-items: center;
  justify-content: center;
  -webkit-justify-content: center;
}

%item-between {
  @extend %flexbox;
  align-items: center;
  justify-content: space-between;
  -webkit-justify-content: space-between;
}

%item-end {
    @extend %flexbox;
    justify-content: flex-end;
  -webkit-justify-content: flex-end;
  }

%item-middle {
  @extend %flexbox;
  align-items: center;
}

%flex-column {
  @extend %flexbox;
  flex-direction: column;
}

%flex-row {
  @extend %flexbox;
  flex-direction: row;
  flex-wrap: wrap;
}

%position-center-box {
  display: block;
  @include position-top-left(50%, 50%);
  @include translate(-50%, -50%);
}

// Font Awesome
%fal {
  font-family: 'Font Awesome 5 Pro';
  font-weight: 300;
}

%fa,
%fas{
  font-family: 'Font Awesome 5 Pro';
  font-weight: 900;
}

//Clearfix
%clearfix {
  &:before,
  &:after {
    content: "";
    display: table;
  }
  &:after {
    clear: both;
  }
}

@mixin images-inline($image-width: null, $image-height: null, $border-radius: null, $bg-color: null, $margin-left: null) {
  .images {
    @include size($image-width, $image-height);
    min-width: $image-width;
    background-color: $bg-color;
    @include border-radius($border-radius);
  }
  .content {
    margin-left: $margin-left;
  }
}